package com.sample;

import java.io.InputStreamReader;
import java.io.Reader;

import org.drools.RuleBase;
import org.drools.RuleBaseFactory;
import org.drools.WorkingMemory;
import org.drools.compiler.PackageBuilder;
import org.drools.rule.Package;

import osnovni_podaci.Osoba;

public class DroolsTest {

    public static final void main(String[] args) {
        try {
        	
        	//Ucitavanje baze znanja
            RuleBase ruleBase = readRules();
            
            //Kreiranje radne memorije
            WorkingMemory workingMemory = ruleBase.newStatefulSession();
            
            //Kreiranje cinjenica
            Osoba o = new Osoba();
            o.setGodine(40);
            o.setIme("Pera");
            o.setPol('N');
            
            Osoba o2 = new Osoba();
            o2.setGodine(26);
            o2.setIme("Lara");
            o2.setPol('Z');
            
            //Unosenje cinjenica u radnu memoriju
            workingMemory.insert( o );
            workingMemory.insert( o2 );
            
            //Pokretanje ES
            workingMemory.fireAllRules();   
            
            
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }

 	private static RuleBase readRules() throws Exception {
		//Ucitavanje pravila iz fajla
		Reader source = new InputStreamReader( DroolsTest.class.getResourceAsStream( "/Sample.drl" ) );
		
		//Kreiranje paketa koji sadrzi sva pravila
		PackageBuilder builder = new PackageBuilder();
		
		builder.addPackageFromDrl( source );
		
		Package pkg = builder.getPackage();
		
		//Kreiranje baze znanja i dodavanje paketa u nju
		RuleBase ruleBase = RuleBaseFactory.newRuleBase();
		ruleBase.addPackage( pkg );
		return ruleBase;
	}
    
}
